package jp.bucketeer.plugin;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

public class SimpleSettableFuture<T> {
  private final CountDownLatch readyLatch = new CountDownLatch(1);
  private volatile T result;

  public SimpleSettableFuture() {
  }

  public void set(T result) {
    if (this.readyLatch.getCount() == 0L) {
      throw new RuntimeException("Result has already been set!");
    } else {
      this.result = result;
      this.readyLatch.countDown();
    }
  }

  public T get() {
    try {
      readyLatch.await(3000, TimeUnit.MILLISECONDS);
    } catch (InterruptedException e) {
      throw new RuntimeException(e);
    }

    return this.result;
  }
}